# Solarus library source files.
file(
  GLOB
  solarus_SOURCES

  include/solarus/audio/ItDecoder.h
  include/solarus/audio/Music.h
  include/solarus/audio/OggDecoder.h
  include/solarus/audio/Sound.h
  include/solarus/audio/SpcDecoder.h

  include/solarus/containers/Grid.h
  include/solarus/containers/Quadtree.h
  include/solarus/containers/Quadtree.inl

  include/solarus/core/Ability.h
  include/solarus/core/AbilityInfo.h
  include/solarus/core/Arguments.h
  include/solarus/core/CommandsEffects.h
  include/solarus/core/Common.h
  include/solarus/core/config.h
  include/solarus/core/Debug.h
  include/solarus/core/CurrentQuest.h
  include/solarus/core/DialogBoxSystem.h
  include/solarus/core/Dialog.h
  include/solarus/core/DialogResources.h
  include/solarus/core/EnumInfo.h
  include/solarus/core/EnumInfo.inl
  include/solarus/core/Equipment.h
  include/solarus/core/EquipmentItem.h
  include/solarus/core/EquipmentItemUsage.h
  include/solarus/core/FontResource.h
  include/solarus/core/GameCommand.h
  include/solarus/core/GameCommands.h
  include/solarus/core/Game.h
  include/solarus/core/Geometry.h
  include/solarus/core/InputEvent.h
  include/solarus/core/Logger.h
  include/solarus/core/MainLoop.h
  include/solarus/core/Map.h
  include/solarus/core/MapData.h
  include/solarus/core/PixelBits.h
  include/solarus/core/Point.h
  include/solarus/core/Point.inl
  include/solarus/core/QuestFiles.h
  include/solarus/core/QuestDatabase.h
  include/solarus/core/QuestProperties.h
  include/solarus/core/Random.h
  include/solarus/core/Rectangle.h
  include/solarus/core/ResourceProvider.h
  include/solarus/core/ResourceType.h
  include/solarus/core/SavegameConverterV1.h
  include/solarus/core/Savegame.h
  include/solarus/core/Settings.h
  include/solarus/core/Scale.h
  include/solarus/core/Scale.inl
  include/solarus/core/Size.h
  include/solarus/core/Size.inl
  include/solarus/core/SolarusFatal.h
  include/solarus/core/String.h
  include/solarus/core/StringResources.h
  include/solarus/core/System.h
  include/solarus/core/Timer.h
  include/solarus/core/TimerPtr.h
  include/solarus/core/Transform.h
  include/solarus/core/Transform.inl
  include/solarus/core/Treasure.h

  include/solarus/entities/AnimatedTilePattern.h
  include/solarus/entities/Arrow.h
  include/solarus/entities/Block.h
  include/solarus/entities/Bomb.h
  include/solarus/entities/Boomerang.h
  include/solarus/entities/BorderKind.h
  include/solarus/entities/BorderSet.h
  include/solarus/entities/Camera.h
  include/solarus/entities/CameraPtr.h
  include/solarus/entities/CarriedObject.h
  include/solarus/entities/Chest.h
  include/solarus/entities/CollisionMode.h
  include/solarus/entities/CrystalBlock.h
  include/solarus/entities/Crystal.h
  include/solarus/entities/CustomEntity.h
  include/solarus/entities/Destination.h
  include/solarus/entities/Destructible.h
  include/solarus/entities/Door.h
  include/solarus/entities/DynamicTile.h
  include/solarus/entities/EnemyAttack.h
  include/solarus/entities/Enemy.h
  include/solarus/entities/EnemyReaction.h
  include/solarus/entities/Entities.h
  include/solarus/entities/Entity.h
  include/solarus/entities/EntityData.h
  include/solarus/entities/EntityPtr.h
  include/solarus/entities/EntityState.h
  include/solarus/entities/EntityType.h
  include/solarus/entities/EntityTypeInfo.h
  include/solarus/entities/Explosion.h
  include/solarus/entities/Fire.h
  include/solarus/entities/Ground.h
  include/solarus/entities/GroundInfo.h
  include/solarus/entities/Hero.h
  include/solarus/entities/HeroPtr.h
  include/solarus/entities/Hookshot.h
  include/solarus/entities/Jumper.h
  include/solarus/entities/Layer.h
  include/solarus/entities/NonAnimatedRegions.h
  include/solarus/entities/Npc.h
  include/solarus/entities/ParallaxScrollingTilePattern.h
  include/solarus/entities/Pickable.h
  include/solarus/entities/SelfScrollingTilePattern.h
  include/solarus/entities/Sensor.h
  include/solarus/entities/Separator.h
  include/solarus/entities/SeparatorPtr.h
  include/solarus/entities/ShopTreasure.h
  include/solarus/entities/SimpleTilePattern.h
  include/solarus/entities/Stairs.h
  include/solarus/entities/StartingLocationMode.h
  include/solarus/entities/StreamAction.h
  include/solarus/entities/Stream.h
  include/solarus/entities/Switch.h
  include/solarus/entities/Teletransporter.h
  include/solarus/entities/Tile.h
  include/solarus/entities/TileInfo.h
  include/solarus/entities/TilePattern.h
  include/solarus/entities/TilePtr.h
  include/solarus/entities/TilesetData.h
  include/solarus/entities/Tileset.h
  include/solarus/entities/TraversableInfo.h
  include/solarus/entities/Wall.h

  include/solarus/graphics/BlendMode.h
  include/solarus/graphics/BlendModeInfo.h
  include/solarus/graphics/Color.h
  include/solarus/graphics/Drawable.h
  include/solarus/graphics/DrawablePtr.h
  include/solarus/graphics/DrawProxies.h
  include/solarus/graphics/Hq2xFilter.h
  include/solarus/graphics/Hq3xFilter.h
  include/solarus/graphics/Hq4xFilter.h
  include/solarus/graphics/RenderTexture.h
  include/solarus/graphics/Scale2xFilter.h
  include/solarus/graphics/SDLPtrs.h
  include/solarus/graphics/Shader.h
  include/solarus/graphics/DefaultShaders.h
  include/solarus/graphics/Renderer.h
  include/solarus/graphics/sdlrenderer/SDLRenderer.h
  include/solarus/graphics/sdlrenderer/SDLSurfaceImpl.h
  include/solarus/graphics/sdlrenderer/SDLShader.h
  include/solarus/graphics/glrenderer/GlRenderer.h
  include/solarus/graphics/glrenderer/GlShader.h
  include/solarus/graphics/glrenderer/GlTexture.h
  include/solarus/graphics/ShaderContext.h
  include/solarus/graphics/ShaderData.h
  include/solarus/graphics/ShaderPtr.h
  include/solarus/graphics/SoftwarePixelFilter.h
  include/solarus/graphics/SoftwareVideoMode.h
  include/solarus/graphics/SpriteAnimationDirection.h
  include/solarus/graphics/SpriteAnimation.h
  include/solarus/graphics/SpriteAnimationSet.h
  include/solarus/graphics/Sprite.h
  include/solarus/graphics/SpriteData.h
  include/solarus/graphics/SpritePtr.h
  include/solarus/graphics/Surface.h
  include/solarus/graphics/SurfaceImpl.h
  include/solarus/graphics/SurfacePtr.h
  include/solarus/graphics/TextSurface.h
  include/solarus/graphics/Texture.h
  include/solarus/graphics/TransitionFade.h
  include/solarus/graphics/Transition.h
  include/solarus/graphics/TransitionImmediate.h
  include/solarus/graphics/TransitionScrolling.h
  include/solarus/graphics/VertexArray.h
  include/solarus/graphics/VertexArrayPtr.h
  include/solarus/graphics/Video.h

  include/solarus/hero/BackToSolidGroundState.h
  include/solarus/hero/BoomerangState.h
  include/solarus/hero/BowState.h
  include/solarus/hero/CarryingState.h
  include/solarus/hero/CustomState.h
  include/solarus/hero/FallingState.h
  include/solarus/hero/ForcedWalkingState.h
  include/solarus/hero/FreeState.h
  include/solarus/hero/FrozenState.h
  include/solarus/hero/GrabbingState.h
  include/solarus/hero/HeroSprites.h
  include/solarus/hero/HeroState.h
  include/solarus/hero/HookshotState.h
  include/solarus/hero/HurtState.h
  include/solarus/hero/JumpingState.h
  include/solarus/hero/LiftingState.h
  include/solarus/hero/PlayerMovementState.h
  include/solarus/hero/PlungingState.h
  include/solarus/hero/PullingState.h
  include/solarus/hero/PushingState.h
  include/solarus/hero/RunningState.h
  include/solarus/hero/SpinAttackState.h
  include/solarus/hero/StairsState.h
  include/solarus/hero/SwimmingState.h
  include/solarus/hero/SwordLoadingState.h
  include/solarus/hero/SwordSwingingState.h
  include/solarus/hero/SwordTappingState.h
  include/solarus/hero/TreasureState.h
  include/solarus/hero/UsingItemState.h
  include/solarus/hero/VictoryState.h

  include/solarus/lua/ExportableToLua.h
  include/solarus/lua/ExportableToLuaPtr.h
  include/solarus/lua/LuaContext.h
  include/solarus/lua/LuaData.h
  include/solarus/lua/LuaException.h
  include/solarus/lua/LuaTools.h
  include/solarus/lua/LuaTools.inl
  include/solarus/lua/ScopedLuaRef.h

  include/solarus/movements/CircleMovement.h
  include/solarus/movements/FallingHeight.h
  include/solarus/movements/FallingOnFloorMovement.h
  include/solarus/movements/JumpMovement.h
  include/solarus/movements/Movement.h
  include/solarus/movements/PathFinding.h
  include/solarus/movements/PathFindingMovement.h
  include/solarus/movements/PathMovement.h
  include/solarus/movements/PixelMovement.h
  include/solarus/movements/PlayerMovement.h
  include/solarus/movements/RandomMovement.h
  include/solarus/movements/RandomPathMovement.h
  include/solarus/movements/RelativeMovement.h
  include/solarus/movements/StraightMovement.h
  include/solarus/movements/TargetMovement.h

  include/solarus/third_party/hqx/common.h
  include/solarus/third_party/hqx/hqx.h
  include/solarus/third_party/snes_spc/blargg_common.h
  include/solarus/third_party/snes_spc/blargg_config.h
  include/solarus/third_party/snes_spc/blargg_endian.h
  include/solarus/third_party/snes_spc/blargg_source.h
  include/solarus/third_party/snes_spc/dsp.h
  include/solarus/third_party/snes_spc/SNES_SPC.h
  include/solarus/third_party/snes_spc/SPC_CPU.h
  include/solarus/third_party/snes_spc/SPC_DSP.h
  include/solarus/third_party/snes_spc/SPC_Filter.h
  include/solarus/third_party/snes_spc/spc.h
  include/solarus/third_party/shelf-pack.h

  src/audio/ItDecoder.cpp
  src/audio/Music.cpp
  src/audio/OggDecoder.cpp
  src/audio/Sound.cpp
  src/audio/SpcDecoder.cpp


  src/core/AbilityInfo.cpp
  src/core/Arguments.cpp
  src/core/CommandsEffects.cpp
  src/core/CurrentQuest.cpp
  src/core/Debug.cpp
  src/core/DialogBoxSystem.cpp
  src/core/Dialog.cpp
  src/core/DialogResources.cpp
  src/core/Equipment.cpp
  src/core/EquipmentItem.cpp
  src/core/EquipmentItemUsage.cpp
  src/core/FontResource.cpp
  src/core/GameCommands.cpp
  src/core/Game.cpp
  src/core/Geometry.cpp
  src/core/InputEvent.cpp
  src/core/Logger.cpp
  src/core/MainLoop.cpp
  src/core/Map.cpp
  src/core/MapData.cpp
  src/core/PixelBits.cpp
  src/core/Point.cpp
  src/core/QuestFiles.cpp
  src/core/QuestDatabase.cpp
  src/core/QuestProperties.cpp
  src/core/Random.cpp
  src/core/Rectangle.cpp
  src/core/ResourceProvider.cpp
  src/core/SavegameConverterV1.cpp
  src/core/Savegame.cpp
  src/core/Settings.cpp
  src/core/Size.cpp
  src/core/SolarusFatal.cpp
  src/core/String.cpp
  src/core/System.cpp
  src/core/StringResources.cpp
  src/core/Timer.cpp
  src/core/Treasure.cpp

  src/entities/AnimatedTilePattern.cpp
  src/entities/Arrow.cpp
  src/entities/Block.cpp
  src/entities/Bomb.cpp
  src/entities/Boomerang.cpp
  src/entities/BorderSet.cpp
  src/entities/Camera.cpp
  src/entities/CarriedObject.cpp
  src/entities/Chest.cpp
  src/entities/CrystalBlock.cpp
  src/entities/Crystal.cpp
  src/entities/CollisionMode.cpp
  src/entities/CustomEntity.cpp
  src/entities/Destination.cpp
  src/entities/Destructible.cpp
  src/entities/Door.cpp
  src/entities/DynamicTile.cpp
  src/entities/Enemy.cpp
  src/entities/EnemyReaction.cpp
  src/entities/Entities.cpp
  src/entities/Entity.cpp
  src/entities/EntityData.cpp
  src/entities/EntityState.cpp
  src/entities/EntityTypeInfo.cpp
  src/entities/Explosion.cpp
  src/entities/Fire.cpp
  src/entities/GroundInfo.cpp
  src/entities/Hero.cpp
  src/entities/Hookshot.cpp
  src/entities/Jumper.cpp
  src/entities/NonAnimatedRegions.cpp
  src/entities/Npc.cpp
  src/entities/ParallaxScrollingTilePattern.cpp
  src/entities/Pickable.cpp
  src/entities/SelfScrollingTilePattern.cpp
  src/entities/Sensor.cpp
  src/entities/Separator.cpp
  src/entities/ShopTreasure.cpp
  src/entities/SimpleTilePattern.cpp
  src/entities/Stairs.cpp
  src/entities/StartingLocationMode.cpp
  src/entities/StreamAction.cpp
  src/entities/Stream.cpp
  src/entities/Switch.cpp
  src/entities/Teletransporter.cpp
  src/entities/Tile.cpp
  src/entities/TilePattern.cpp
  src/entities/Tileset.cpp
  src/entities/TilesetData.cpp
  src/entities/TraversableInfo.cpp
  src/entities/Wall.cpp

  src/graphics/BlendModeInfo.cpp
  src/graphics/Color.cpp
  src/graphics/Drawable.cpp
  src/graphics/Hq2xFilter.cpp
  src/graphics/Hq3xFilter.cpp
  src/graphics/Hq4xFilter.cpp
  src/graphics/RenderTexture.cpp
  src/graphics/Renderer.cpp
  src/graphics/sdlrenderer/SDLRenderer.cpp
  src/graphics/sdlrenderer/SDLSurfaceImpl.cpp
  src/graphics/sdlrenderer/SDLShader.cpp
  src/graphics/glrenderer/GlRenderer.cpp
  src/graphics/glrenderer/GlShader.cpp
  src/graphics/glrenderer/GlTexture.cpp
  src/graphics/Scale2xFilter.cpp
  src/graphics/ShaderContext.cpp
  src/graphics/ShaderData.cpp
  src/graphics/Shader.cpp
  src/graphics/SoftwarePixelFilter.cpp
  src/graphics/SoftwareVideoMode.cpp
  src/graphics/SpriteAnimation.cpp
  src/graphics/SpriteAnimationDirection.cpp
  src/graphics/SpriteAnimationSet.cpp
  src/graphics/Sprite.cpp
  src/graphics/SpriteData.cpp
  src/graphics/Surface.cpp
  src/graphics/SurfaceImpl.cpp
  src/graphics/TextSurface.cpp
  src/graphics/Texture.cpp
  src/graphics/Transition.cpp
  src/graphics/TransitionFade.cpp
  src/graphics/TransitionImmediate.cpp
  src/graphics/TransitionScrolling.cpp
  src/graphics/VertexArray.cpp
  src/graphics/Video.cpp

  src/hero/BackToSolidGroundState.cpp
  src/hero/BoomerangState.cpp
  src/hero/BowState.cpp
  src/hero/CarryingState.cpp
  src/hero/CustomState.cpp
  src/hero/FallingState.cpp
  src/hero/ForcedWalkingState.cpp
  src/hero/FreeState.cpp
  src/hero/FrozenState.cpp
  src/hero/GrabbingState.cpp
  src/hero/HeroSprites.cpp
  src/hero/HeroState.cpp
  src/hero/HookshotState.cpp
  src/hero/HurtState.cpp
  src/hero/JumpingState.cpp
  src/hero/LiftingState.cpp
  src/hero/PlayerMovementState.cpp
  src/hero/PlungingState.cpp
  src/hero/PullingState.cpp
  src/hero/PushingState.cpp
  src/hero/RunningState.cpp
  src/hero/SpinAttackState.cpp
  src/hero/StairsState.cpp
  src/hero/SwimmingState.cpp
  src/hero/SwordLoadingState.cpp
  src/hero/SwordSwingingState.cpp
  src/hero/SwordTappingState.cpp
  src/hero/TreasureState.cpp
  src/hero/UsingItemState.cpp
  src/hero/VictoryState.cpp

  src/lua/AudioApi.cpp
  src/lua/DrawableApi.cpp
  src/lua/EntityApi.cpp
  src/lua/ExportableToLua.cpp
  src/lua/FileApi.cpp
  src/lua/GameApi.cpp
  src/lua/InputApi.cpp
  src/lua/ItemApi.cpp
  src/lua/LanguageApi.cpp
  src/lua/LuaContext.cpp
  src/lua/LuaData.cpp
  src/lua/LuaException.cpp
  src/lua/LuaTools.cpp
  src/lua/MainApi.cpp
  src/lua/MapApi.cpp
  src/lua/MenuApi.cpp
  src/lua/MovementApi.cpp
  src/lua/ScopedLuaRef.cpp
  src/lua/ShaderApi.cpp
  src/lua/SpriteApi.cpp
  src/lua/StateApi.cpp
  src/lua/SurfaceApi.cpp
  src/lua/TextSurfaceApi.cpp
  src/lua/TimerApi.cpp
  src/lua/VideoApi.cpp

  src/movements/CircleMovement.cpp
  src/movements/FallingOnFloorMovement.cpp
  src/movements/JumpMovement.cpp
  src/movements/Movement.cpp
  src/movements/PathFinding.cpp
  src/movements/PathFindingMovement.cpp
  src/movements/PathMovement.cpp
  src/movements/PixelMovement.cpp
  src/movements/PlayerMovement.cpp
  src/movements/RandomMovement.cpp
  src/movements/RandomPathMovement.cpp
  src/movements/RelativeMovement.cpp
  src/movements/StraightMovement.cpp
  src/movements/TargetMovement.cpp

  src/third_party/hqx/hq2x.c
  src/third_party/hqx/hq3x.c
  src/third_party/hqx/hq4x.c
  src/third_party/hqx/init.c
  src/third_party/snes_spc/dsp.cpp
  src/third_party/snes_spc/SNES_SPC.cpp
  src/third_party/snes_spc/SNES_SPC_misc.cpp
  src/third_party/snes_spc/SNES_SPC_state.cpp
  src/third_party/snes_spc/spc.cpp
  src/third_party/snes_spc/SPC_DSP.cpp
  src/third_party/snes_spc/SPC_Filter.cpp
)

# Additional source files for Apple systems.
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(solarus_SOURCES
    ${solarus_SOURCES}
    src/core/AppleInterface.mm
    include/solarus/core/AppleInterface.h
    )
endif()

# Build the Solarus library.
add_library(solarus
  SHARED
  ${solarus_SOURCES}
)

target_link_libraries(solarus
  "${SDL2_LIBRARY}"
  "${SDL2_IMAGE_LIBRARY}"
  "${SDL2_TTF_LIBRARY}"
  "${OPENGL_LIBRARY}"
  "${OPENAL_LIBRARY}"
  "${LUA_LIBRARY}"
  "${DL_LIBRARY}"
  "${PHYSFS_LIBRARY}"
  "${VORBIS_LIBRARY}"
  "${VORBISFILE_LIBRARY}"
  "${OGG_LIBRARY}"
  "${MODPLUG_LIBRARY}"
)

set_target_properties(solarus PROPERTIES
  VERSION ${SOLARUS_VERSION_STRING}
  SOVERSION ${SOLARUS_MAJOR_VERSION}
)

# Configuration for OSX and iOS build and deployment.
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  if(NOT SOLARUS_IOS_BUILD)
    include(cmake/apple/OSXBuild.cmake)
  else()
    include(cmake/apple/iOSBuild.cmake)
  endif()
endif()

